#ifndef _arrmac_h
#define _arrmac_h

#include <corba.h>

#if defined(__STDC__) || defined(__ANSI_CPP__) || defined(__DECCXX) || defined(__BORLANDC__)
#define __ArrayName(TYPENAME,DEPTH) ArrayName_##TYPENAME##_##DEPTH
#define ArrayName(TYPENAME,DEPTH) __ArrayName(TYPENAME,DEPTH)
#else
#define __ArrayName(TYPENAME,DEPTH) ArrayName_/**/TYPENAME/**/_/**/DEPTH
#define ArrayName(TYPENAME,DEPTH) __ArrayName(TYPENAME,DEPTH)
#endif

#define IDLArray(TYPENAME) ArrayName(TYPENAME,1)

#define DECLARE_PRIMITIVE_ARRAY(SIZE,TYPENAME,DEPTH,TYPE)		\
	class ArrayName(TYPENAME,DEPTH) : public CORBA::Array {	\
		DECLARE_NCOBJECT_CLASS(ArrayName(TYPENAME,DEPTH));	\
		public:						\
			typedef TYPE ArrayName(TYPENAME,0);	\
		private:						\
			static const CORBA::ULong _max_size;		\
			ArrayName(TYPENAME,0) _array_var[SIZE];	\
		public:							\
			void copyFrom(NCistream& strm);			\
			ArrayName(TYPENAME,DEPTH)(const        	\
				ArrayName(TYPENAME,DEPTH)& obj);   \
			void operator=(const 				\
				ArrayName(TYPENAME,DEPTH)& obj);   \
			ArrayName(TYPENAME,DEPTH)();			\
			ArrayName(TYPENAME,0)			\
			&operator[](CORBA::ULong i) { return _array_var[i]; }\
			const ArrayName(TYPENAME,0)		\
			&operator[](CORBA::ULong i) const { return _array_var[i]; } \
	}



#define IMPLEMENT_PRIMITIVE_ARRAY(SIZE,TYPENAME,DEPTH,SCOPE,TYPE)	\
DEFINE_NCOBJECT_CLASS1(SCOPE ArrayName(TYPENAME,DEPTH), CORBA::Array);\
const CORBA::ULong SCOPE ArrayName(TYPENAME,DEPTH)::_max_size = SIZE;\
SCOPE ArrayName(TYPENAME,DEPTH)::ArrayName(TYPENAME,DEPTH)()		\
{									\
	for (CORBA::ULong i=0; i < SIZE; i++)				\
		_array_var[i] = (TYPE) 0;				\
}									\
int SCOPE ArrayName(TYPENAME,DEPTH)::compare(const NCObject& obj) const\
{									\
	int diff;							\
	const ArrayName(TYPENAME,DEPTH)& temp = 			\
		NCCONST_REF_CAST(ArrayName(TYPENAME,DEPTH), obj);	\
	for (CORBA::ULong i=0; i< _max_size; i++) {			\
		if ( (diff = (int) _array_var[i] - (int)temp[i]) != 0)	\
			return diff;					\
	}								\
	return 0;							\
}									\
									\
unsigned SCOPE ArrayName(TYPENAME,DEPTH)::hash() const		\
{									\
	unsigned h = (unsigned)_max_size;				\
	for (CORBA::ULong i=0; i< _max_size; i++)			\
		h ^= (unsigned) _array_var[i];				\
	return h;							\
}									\
									\
SCOPE ArrayName(TYPENAME,DEPTH)::ArrayName(TYPENAME,DEPTH)(NCistream& strm) : CORBA::Array(strm)	\
{									\
	strm.get(_array_var, (unsigned int)_max_size);			\
}									\
									\
SCOPE ArrayName(TYPENAME,DEPTH)::ArrayName(TYPENAME,DEPTH)(const ArrayName(TYPENAME,DEPTH)& obj) 	\
{									\
	for (CORBA::ULong i=0; i< _max_size; i++) {			\
		_array_var[i] = obj[i];					\
	}								\
}									\
									\
void SCOPE ArrayName(TYPENAME,DEPTH)::copyFrom(NCistream& strm) 	\
{									\
	strm.get(_array_var, (unsigned int)_max_size);			\
}									\
									\
void SCOPE ArrayName(TYPENAME,DEPTH)::operator=(const ArrayName(TYPENAME,DEPTH)& obj) 	\
{									\
	for (CORBA::ULong i=0; i< _max_size; i++) {			\
		_array_var[i] = obj[i];					\
	}								\
}									\
									\
void SCOPE ArrayName(TYPENAME,DEPTH)::write(NCostream& strm) const	\
{									\
	CORBA::Array::write(strm);					\
	strm.put(_array_var, (unsigned int)_max_size);			\
}									\
									\
void SCOPE ArrayName(TYPENAME,DEPTH)::prettyPrint(NCostream& strm) const\
{									\
	for (CORBA::ULong i=0; i< _max_size; i++) {			\
		strm << "ARRAY ELEMENT NUM: " << i << " = ";		\
		strm << _array_var[i] << endl;				\
	}								\
}



#define DECLARE_CONSTRUCTED_ARRAY(SIZE,TYPENAME,DEPTH,TYPE)		\
	class ArrayName(TYPENAME,DEPTH) : public CORBA::Array {	\
		DECLARE_NCOBJECT_CLASS(ArrayName(TYPENAME,DEPTH));	\
		public:							\
			typedef TYPE ArrayName(TYPENAME,0);	\
		private:						\
			static const CORBA::ULong _max_size;		\
			ArrayName(TYPENAME,0) _array_var[SIZE];	\
		public:							\
			void copyFrom(NCistream& strm);			\
			ArrayName(TYPENAME,DEPTH)(const        	\
			ArrayName(TYPENAME,DEPTH)& obj);           \
			void operator=(const 				\
			ArrayName(TYPENAME,DEPTH)& obj);           \
			ArrayName(TYPENAME,DEPTH)() {}		\
			ArrayName(TYPENAME,0)			\
			&operator[](CORBA::ULong i) { return _array_var[i]; }	\
			const ArrayName(TYPENAME,0)		\
			&operator[](CORBA::ULong i) const { return _array_var[i]; } \
	}



#define IMPLEMENT_CONSTRUCTED_ARRAY(SIZE,TYPENAME,DEPTH,SCOPE,TYPE)	\
DEFINE_NCOBJECT_CLASS1(SCOPE ArrayName(TYPENAME,DEPTH), CORBA::Array);	\
const CORBA::ULong SCOPE ArrayName(TYPENAME,DEPTH)::_max_size = SIZE;	\
int SCOPE ArrayName(TYPENAME,DEPTH)::compare(const NCObject& obj) const	\
{									\
	int diff;							\
	const ArrayName(TYPENAME,DEPTH)& temp = NCCONST_REF_CAST(ArrayName(TYPENAME,DEPTH), obj);	\
	for (CORBA::ULong i=0; i< _max_size; i++) {			\
		if ( (diff = _array_var[i].compare(temp[i])) != 0)	\
			return diff;					\
	}								\
	return 0;							\
}									\
									\
unsigned SCOPE ArrayName(TYPENAME,DEPTH)::hash() const		\
{									\
	unsigned h = (unsigned)_max_size;				\
	for (CORBA::ULong i=0; i< _max_size; i++)			\
		h ^= _array_var[i].hash();				\
	return h;							\
}									\
									\
SCOPE ArrayName(TYPENAME,DEPTH)::ArrayName(TYPENAME,DEPTH)(NCistream& strm) : CORBA::Array(strm)	\
{									\
	for (CORBA::ULong i=0; i< _max_size; i++) {			\
		_array_var[i].get(strm);				\
	}								\
}									\
									\
SCOPE ArrayName(TYPENAME,DEPTH)::ArrayName(TYPENAME,DEPTH)(const ArrayName(TYPENAME,DEPTH)& obj) 	\
{									\
	for (CORBA::ULong i=0; i< _max_size; i++) {			\
		_array_var[i] = obj[i];					\
	}								\
}									\
									\
void SCOPE ArrayName(TYPENAME,DEPTH)::copyFrom(NCistream& strm) 	\
{									\
	for (CORBA::ULong i=0; i< _max_size; i++) {			\
		_array_var[i].get(strm);				\
	}								\
}									\
									\
void SCOPE ArrayName(TYPENAME,DEPTH)::operator=(const ArrayName(TYPENAME,DEPTH)& obj) 	\
{									\
	for (CORBA::ULong i=0; i< _max_size; i++) {			\
		_array_var[i] = obj[i];					\
	}								\
}									\
									\
void SCOPE ArrayName(TYPENAME,DEPTH)::write(NCostream& strm) const	\
{									\
	CORBA::Array::write(strm);					\
	for (CORBA::ULong i=0; i< _max_size; i++) 			\
		_array_var[i].put(strm);				\
}									\
									\
void SCOPE ArrayName(TYPENAME,DEPTH)::prettyPrint(NCostream& strm) const\
{									\
	for (CORBA::ULong i=0; i< _max_size; i++) {			\
		strm << "ARRAY ELEMENT NUM: " << i << " = ";		\
		_array_var[i].prettyPrint(strm);			\
		strm << endl;						\
	}								\
}


#define DECLARE_ENUM_ARRAY(SIZE,TYPENAME,DEPTH,TYPE)			\
	class ArrayName(TYPENAME,DEPTH) : public CORBA::Array {	\
		DECLARE_NCOBJECT_CLASS(ArrayName(TYPENAME,DEPTH));	\
		public:							\
			typedef TYPE ArrayName(TYPENAME,0);	\
		private:						\
			static const CORBA::ULong _max_size;		\
			ArrayName(TYPENAME,0) _array_var[SIZE];	\
		public:							\
			void copyFrom(NCistream& strm);			\
			ArrayName(TYPENAME,DEPTH)(const        	\
				ArrayName(TYPENAME,DEPTH)& obj);   \
			void operator=(const 				\
				ArrayName(TYPENAME,DEPTH)& obj);   \
			ArrayName(TYPENAME,DEPTH)();			\
			ArrayName(TYPENAME,0)			\
			&operator[](CORBA::ULong i) { return _array_var[i]; }\
			const ArrayName(TYPENAME,0)		\
			&operator[](CORBA::ULong i) const { return _array_var[i]; } \
	}



#define IMPLEMENT_ENUM_ARRAY(SIZE,TYPENAME,DEPTH,SCOPE,TYPE)		\
DEFINE_NCOBJECT_CLASS1(SCOPE ArrayName(TYPENAME,DEPTH), CORBA::Array);\
const CORBA::ULong SCOPE ArrayName(TYPENAME,DEPTH)::_max_size = SIZE;\
SCOPE ArrayName(TYPENAME,DEPTH)::ArrayName(TYPENAME,DEPTH)()		\
{									\
	for (CORBA::ULong i=0; i < SIZE; i++)				\
		_array_var[i] = (TYPE) 0;				\
}									\
int SCOPE ArrayName(TYPENAME,DEPTH)::compare(const NCObject& obj) const\
{									\
	int diff;							\
	const ArrayName(TYPENAME,DEPTH)& temp = 			\
		NCCONST_REF_CAST(ArrayName(TYPENAME,DEPTH), obj);	\
	for (CORBA::ULong i=0; i< _max_size; i++) {			\
		if ( (diff = (int) _array_var[i] - (int)temp[i]) != 0)	\
			return diff;					\
	}								\
	return 0;							\
}									\
									\
unsigned SCOPE ArrayName(TYPENAME,DEPTH)::hash() const		\
{									\
	unsigned h = (unsigned)_max_size;				\
	for (CORBA::ULong i=0; i< _max_size; i++)			\
		h ^= (unsigned) _array_var[i];				\
	return h;							\
}									\
									\
SCOPE ArrayName(TYPENAME,DEPTH)::ArrayName(TYPENAME,DEPTH)(NCistream& strm) : CORBA::Array(strm)	\
{									\
	CORBA::ULong temp;						\
	for (CORBA::ULong i=0; i < _max_size; i++) {			\
		strm >> temp;						\
		_array_var[i] = TYPE(temp);				\
	}								\
}									\
									\
SCOPE ArrayName(TYPENAME,DEPTH)::ArrayName(TYPENAME,DEPTH)(const ArrayName(TYPENAME,DEPTH)& obj) 	\
{									\
	for (CORBA::ULong i=0; i< _max_size; i++) {			\
		_array_var[i] = obj[i];					\
	}								\
}									\
									\
void SCOPE ArrayName(TYPENAME,DEPTH)::copyFrom(NCistream& strm) 	\
{									\
	CORBA::ULong temp;						\
	for (CORBA::ULong i=0; i < _max_size; i++) {			\
		strm >> temp;						\
		_array_var[i] = TYPE(temp);				\
	}								\
}									\
									\
void SCOPE ArrayName(TYPENAME,DEPTH)::operator=(const ArrayName(TYPENAME,DEPTH)& obj) 	\
{									\
	for (CORBA::ULong i=0; i< _max_size; i++) {			\
		_array_var[i] = obj[i];					\
	}								\
}									\
									\
void SCOPE ArrayName(TYPENAME,DEPTH)::write(NCostream& strm) const	\
{									\
	CORBA::Array::write(strm);					\
	for (CORBA::ULong i=0; i < _max_size; i++)			\
		strm << (CORBA::ULong) _array_var[i];			\
}									\
									\
void SCOPE ArrayName(TYPENAME,DEPTH)::prettyPrint(NCostream& strm) const\
{									\
	for (CORBA::ULong i=0; i< _max_size; i++) {			\
		strm << "ARRAY ELEMENT NUM: " << i << " = ";		\
		strm << _array_var[i] << endl;				\
	}								\
}



#define DECLARE_INTERFACE_ARRAY(SIZE,TYPENAME,DEPTH,TYPE)		\
	class ArrayName(TYPENAME,DEPTH) : public CORBA::Array {		\
		DECLARE_NCOBJECT_CLASS(ArrayName(TYPENAME,DEPTH));	\
		public:							\
			typedef TYPE* ArrayName(TYPENAME,0);		\
		private:						\
			static const CORBA::ULong _max_size;		\
			ArrayName(TYPENAME,0) _array_var[SIZE];		\
		public:							\
			void copyFrom(NCistream& strm);			\
			ArrayName(TYPENAME,DEPTH)(const        		\
			ArrayName(TYPENAME,DEPTH)& obj);           	\
			void operator=(const 				\
			ArrayName(TYPENAME,DEPTH)& obj);           	\
			ArrayName(TYPENAME,DEPTH)();			\
			~ArrayName(TYPENAME,DEPTH)();			\
			ArrayName(TYPENAME,0)				\
			&operator[](CORBA::ULong i) { return _array_var[i]; }\
			const ArrayName(TYPENAME,0)			\
			&operator[](CORBA::ULong i) const { return _array_var[i]; } \
	}



#define IMPLEMENT_INTERFACE_ARRAY(SIZE,TYPENAME,DEPTH,SCOPE,TYPE)	\
DEFINE_NCOBJECT_CLASS1(SCOPE ArrayName(TYPENAME,DEPTH), CORBA::Array);	\
const CORBA::ULong SCOPE ArrayName(TYPENAME,DEPTH)::_max_size = SIZE;			\
int SCOPE ArrayName(TYPENAME,DEPTH)::compare(const NCObject& obj) const\
{									\
	int diff;							\
	const ArrayName(TYPENAME,DEPTH)& temp = NCCONST_REF_CAST(ArrayName(TYPENAME,DEPTH), obj);	\
	for (CORBA::ULong i=0; i< _max_size; i++) {			\
		if ( (diff = (int)((unsigned long)_array_var[i] - 	\
				 (unsigned long)temp[i]) != 0)		\
			return diff;					\
	}								\
	return 0;							\
}									\
									\
unsigned SCOPE ArrayName(TYPENAME,DEPTH)::hash() const			\
{									\
	unsigned h = (unsigned)_max_size;				\
	for (CORBA::ULong i=0; i< _max_size; i++)			\
		h ^= (unsigned)(unsigned long) _array_var[i];		\
	return h;							\
}									\
									\
SCOPE ArrayName(TYPENAME,DEPTH)::ArrayName(TYPENAME,DEPTH)(NCistream& strm) : CORBA::Array(strm)	\
{									\
	for (CORBA::ULong i=0; i< _max_size; i++) {			\
		_array_var[i] = TYPE::_narrow(CORBA::Object::_read(strm, TYPE::_desc())); \
		if (_array_var[i])					\
			_array_var[i]->_ref();				\
	}								\
}									\
									\
SCOPE ArrayName(TYPENAME,DEPTH)::ArrayName(TYPENAME,DEPTH)()		\
{									\
	for (CORBA::ULong i=0; i< _max_size; i++) {			\
		_array_var[i] = NULL;					\
	}								\
}									\
									\
SCOPE ArrayName(TYPENAME,DEPTH)::~ArrayName(TYPENAME,DEPTH)()		\
{									\
	for (CORBA::ULong i=0; i< _max_size; i++) {			\
		if (_array_var[i] != NULL)				\
			_array_var[i]->_release();			\
	}								\
}									\
									\
SCOPE ArrayName(TYPENAME,DEPTH)::ArrayName(TYPENAME,DEPTH)(const ArrayName(TYPENAME,DEPTH)& obj) 	\
{									\
	for (CORBA::ULong i=0; i< _max_size; i++) {			\
		_array_var[i] = obj[i];					\
		if (_array_var[i])					\
			_array_var[i]->_ref();				\
	}								\
}									\
									\
void SCOPE ArrayName(TYPENAME,DEPTH)::copyFrom(NCistream& strm) 	\
{									\
	for (CORBA::ULong i=0; i< _max_size; i++) {			\
		_array_var[i] = TYPE::_narrow(CORBA::Object::_read(strm, TYPE::_desc())); \
		if (_array_var[i])					\
			_array_var[i]->_ref();				\
	}								\
}									\
									\
void SCOPE ArrayName(TYPENAME,DEPTH)::operator=(const ArrayName(TYPENAME,DEPTH)& obj) 	\
{									\
	for (CORBA::ULong i=0; i< _max_size; i++) {			\
		_array_var[i] = obj[i];					\
		if (_array_var[i])					\
			_array_var[i]->_ref();				\
	}								\
}									\
									\
void SCOPE ArrayName(TYPENAME,DEPTH)::write(NCostream& strm) const	\
{									\
	CORBA::Array::write(strm);					\
	for (CORBA::ULong i=0; i< _max_size; i++) 			\
		CORBA::Object::_write(_array_var[i], strm, 		\
			TYPE::_desc());				\
}									\
									\
void SCOPE ArrayName(TYPENAME,DEPTH)::prettyPrint(NCostream& strm) const\
{									\
	for (CORBA::ULong i=0; i< _max_size; i++) {			\
		strm << "ARRAY ELEMENT NUM: " << i << " = ";		\
		if (_array_var[i] != NULL)				\
			strm << _array_var[i]->_interface_name();	\
		else							\
			strm << "NULL";					\
		strm << endl;						\
	}								\
}




#endif





