#ifndef _corba_string_h
#define _corba_string_h
/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1993, 1994 by PostModern Computing Technologies, Inc.         */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/****************************************************************************/

class String: public DSResource
{
	DECLARE_NCOBJECT_CLASS(String);
    private:	
	char		*_str;
	CORBA::ULong	_len;

    public:
	String(const char *str);
	String();
	String(const String& );
	virtual ~String();
	void copyFrom(NCistream& strm);
	void get(NCistream& strm) { copyFrom(strm); }
	void put(NCostream& strm) const { write(strm); }

	operator const char *() const { return _str; }
	void operator=(const String& );
	void operator=(const char *);
	NCbool operator!=(const NCObject& p) const {
		return (!isEqual(p));
	}
	NCbool operator!=(const char *str) const {
		return strcmp(_str, str) != 0;
	}
	NCbool operator==(const NCObject& p) const {
		return isEqual(p);
	}
	NCbool operator==(const char *str) const {
		return strcmp(_str, str) == 0;
	}
	NCbool operator<(const String& s) const {
		return strcmp(_str, s._str) < 0;
	}
	NCbool operator>(const String& s) const  {
		return strcmp(_str, s._str) > 0;
	}
	NCbool operator<=(const String& s) const {
		return strcmp(_str, s._str) <= 0;
	}
	NCbool operator>=(const String& s) const {
		return strcmp(_str, s._str) >= 0;
	}
	NCbool operator<(const char* s) const {
		return strcmp(_str, s) < 0;
	}
	NCbool operator>(const char* s) const  {
		return strcmp(_str, s) > 0;
	}
	NCbool operator<=(const char* s) const {
		return strcmp(_str, s) <= 0;
	}
	NCbool operator>=(const char* s) const {
		return strcmp(_str, s) >= 0;
	}
	String operator&(const String& s) const;
	String operator&(const char *c) const;
	String& operator&=(const String& s);
	String& operator&=(const char *s);
	char operator[](CORBA::Long i) const {
		if ( i >= _len)
			return '\0';
		else
			return *(_str + i);
	}
	NCbool replace(CORBA::Long pos, char val) {
		if ( pos >= _len )
			return 0;
		else {
			*(_str + pos) = val;
			return 1;
		}
	}
			
	CORBA::Long length() const { return _len; }
};

#endif	

