// "@(#)Module Name: dscltn.h Version:2.1 Date: 94/06/19"
#ifndef _ncrcltn_h
#define _ncrcltn_h
/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1993, 1994 by PostModern Computing Technologies, Inc.         */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/****************************************************************************/
#include <dsresour.h>

// -------------------------------------------------------------------------
// Base class for all resource container classes. DSSet, DSOrderedCltn etc 
// are all derived from this class. Collections are containers for other 
// DSResource classes. Objects can be added to collections, searched in 
// collections etc.  When a resource is added to a container, the resource 
// count is incremented. The resource count is decremented when the resource 
// if removed from Collection.
// -------------------------------------------------------------------------
class DSIterator;
class DSCollection: public DSResource
{
	DECLARE_TABSTRACT_CLASS(DSCollection);
    protected:
	friend  DSIterator;
	virtual DSResource *value(DSResource *obj) const { return obj; }
    public:
	DSCollection();
	virtual ~DSCollection() {}
	
	virtual DSResource* add(DSResource& ) =0;
	virtual NCbool  remove(const DSResource& ) =0;
	virtual void 	removeAll() =0;
	virtual unsigned size() const =0;
	virtual unsigned occurrencesOf(const DSResource& ) const =0;
	virtual DSResource* doNext(DSIterator& ) const =0;

	NCbool	includes(const DSResource& p) const {
		return ( occurrencesOf(p) != 0 );
	}
	virtual isEmpty() const { return (size() == 0); }
	virtual void doReset(DSIterator& ) const;
	virtual void prettyPrint(NCostream& strm) const;
};


inline DSCollection::DSCollection(NCistream& strm): DSResource(strm) {}
inline void DSCollection::write(NCostream& ) const {}

#endif
