// "@(#)Module Name: dsresource.h Version:2.2 Date: 94/06/19"
#ifndef _dsresource_h
#define _dsresource_h
/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1993, 1994 by PostModern Computing Technologies, Inc.         */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/****************************************************************************/
#include <ncobject.h>
#include <ncresour.h>


// ------------------------------------------------------------------------
// Representation of a shared resource. Most of the Distributed services
// classes are derived from this class, to keep track of number of references
// to a shared resource. Classes deriving from DSResource should not be
// deleted but 'unref ed'.
// ------------------------------------------------------------------------

class DSResource: public NCObject, public NCResource
{
    private:
#ifdef PSOS
	static NCTypeInfo		class_info;
#else
	static const NCTypeInfo		class_info;
#endif
    public:
	static const NCTypeInfo *desc()  { return &class_info; }
	DSResource();
	DSResource(NCistream& strm);
	virtual ~DSResource();
	inline friend NCistream& operator>>(NCistream& strm, DSResource*& obj){
		obj = (DSResource *)strm.readTransObj();
		return strm;
	}
	// The following are redefined to make GCC compile properly.
	virtual void write(NCostream& ) const {}
	virtual void prettyPrint(NCostream& ) const {}
	virtual unsigned hash() const { return 0; }
	virtual int compare(const NCObject& ) const { return -1; }


	DSResource	*_duplicate() { ref(); return this; }
	void		_release() { unref(); }
};
#endif
