// "@(#)Module Name: dsset.h Version:2.1 Date: 94/06/19"
#ifndef _dsset_h
#define _dsset_h
/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1993, 1994 by PostModern Computing Technologies, Inc.         */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/****************************************************************************/
#include <dscltn.h>

// -------------------------------------------------------------------------
// Implemenation of a Set of Objects. Sets use isEqual to compare Objects
// -------------------------------------------------------------------------

class DSSet: public DSCollection
{
	DECLARE_TRANS_CLASS(DSSet);
    protected:
	unsigned	_capacity;
	unsigned	_count;
	unsigned	_nbits;
	unsigned	_mask;
	DSResource	**_objArray;

	unsigned	setCapacity(unsigned);
	int		h(unsigned long) const;
	virtual int	findIndexOf(const DSResource& )const;
	void		reSize(unsigned newSize);
	
    public:
	virtual int	compare(const NCObject& p) const;
	virtual unsigned hash() const;
	
	DSSet(unsigned size = 16);
	DSSet(const DSSet& set);
	virtual ~DSSet();

	void operator=(const DSSet& );

	DSSet *intersectionOf(const DSSet& ) const;	// intersection
	DSSet *unionOf(const DSSet& ) const;		// union
	DSSet *differenceOf(const DSSet& ) const;	// difference

	virtual DSResource *add(DSResource& );
	virtual NCbool remove(const DSResource& );
	virtual void removeAll();
	virtual unsigned occurrencesOf(const DSResource& ) const; 
	virtual DSResource *doNext(DSIterator& ) const;

	virtual DSResource *findObjectWithKey(const DSResource& ) const ;
	virtual unsigned size() const { return _count; }
	virtual unsigned capacity() const { return _capacity; }
};
#endif
