// "@(#)Module Name: ncresource.h Version:2.2 Date: 94/06/19"
#ifndef _ncresource_h
#define _ncresource_h
/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1993, 1994 by PostModern Computing Technologies, Inc.         */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/****************************************************************************/
#include <iostream.h>
#ifndef PSOS
#include <stdlib.h>
#endif
// --------------------------------------------------------------------------
// Class to keep track of shared resources. Reference counts show the
// number of references to a shared resources. This is the base class for
// Objects that need to be shared. delete should not normally be called on
// instances of classes derived from this classes (use unref).
// --------------------------------------------------------------------------
class NCResource
{
    private:
	unsigned	_ref_count;
    public:
	NCResource() { _ref_count = 0; }
	virtual ~NCResource();
	// Prevent copying of count
	NCResource(const NCResource& ) { _ref_count = 0; }
	void operator=(const NCResource& ) { _ref_count = 0; }


	static  void ref(NCResource *obj);
	static  void unref(NCResource *obj);

	void ref() { _ref_count++; }
	void unref();
	unsigned numRefs() const { return _ref_count; }
	
};

#endif
