#ifndef _seqmac_h_
#define _seqmac_h_
/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1993, 1994 by PostModern Computing Technologies, Inc.         */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/****************************************************************************/

#include <corba.h>

#if defined(__STDC__) || defined(__ANSI_CPP__) || defined(__DECCXX) || defined(__BORLANDC__)
#define __IDLSequence(TYPENAME) _IDL_SEQUENCE_##TYPENAME
#define IDLSequence(TYPENAME) __IDLSequence(TYPENAME)
#else
#define __IDLSequence(TYPENAME) _IDL_SEQUENCE_/**/TYPENAME
#define IDLSequence(TYPENAME) __IDLSequence(TYPENAME)
#endif


#define DECLARE_PRIMITIVE_SEQUENCE(TYPENAME,TYPE) 			\
class IDLSequence(TYPENAME): public CORBA::Sequence			\
{									\
	DECLARE_NCOBJECT_CLASS(IDLSequence(TYPENAME));			\
    private:								\
	TYPE		*_contents;					\
	CORBA::ULong	_count;						\
	CORBA::ULong	_num_allocated;					\
									\
									\
    public:								\
	static const IDLSequence(TYPENAME)	_nil;			\
									\
	IDLSequence(TYPENAME)(CORBA::ULong initial_capacity=16);	\
	IDLSequence(TYPENAME)(const IDLSequence(TYPENAME)& );		\
	IDLSequence(TYPENAME)& operator=(const IDLSequence(TYPENAME)&);	\
	~IDLSequence(TYPENAME)();					\
	void copyFrom(NCistream &strm);					\
	CORBA::ULong length() const { return _count; }			\
									\
	void	insert(TYPE element, CORBA::ULong index);		\
	CORBA::ULong append(TYPE element);				\
	void	remove(CORBA::ULong index);				\
									\
	const TYPE operator[](CORBA::ULong index) const;		\
	TYPE& operator[](CORBA::ULong index);				\
	CORBA::Boolean _is_nil() const { return this == &_nil; }	\
}									

#define IMPLEMENT_PRIMITIVE_SEQUENCE(TYPENAME,TYPE,SCOPE)		\
DEFINE_NCOBJECT_CLASS1(SCOPE IDLSequence(TYPENAME), CORBA::Sequence);	\
const SCOPE IDLSequence(TYPENAME) SCOPE IDLSequence(TYPENAME)::_nil(0); \
									\
int SCOPE IDLSequence(TYPENAME)::compare(const NCObject& obj) const	\
{									\
	const SCOPE IDLSequence(TYPENAME)& temp = 			\
		NCCONST_REF_CAST(SCOPE IDLSequence(TYPENAME), obj);	\
	int diff = (int)(_count - temp._count);				\
	if ( diff != 0)							\
		return diff;						\
	for (CORBA::ULong i=0; i< _count; i++) {			\
		if ( (diff = ((int)_contents[i] - (int)temp._contents[i])) != 0)\
			return diff;					\
	}								\
	return 0;							\
}									\
									\
unsigned SCOPE IDLSequence(TYPENAME)::hash() const			\
{									\
	unsigned h = (unsigned)_count;					\
	for (CORBA::ULong i=0; i< _count; i++)				\
		h ^= (unsigned) _contents[i];				\
	return h;							\
}									\
									\
SCOPE IDLSequence(TYPENAME)::IDLSequence(TYPENAME)(NCistream& strm) : CORBA::Sequence(strm)	\
{									\
	strm >> _num_allocated >> _count;				\
	_contents = new TYPE[_num_allocated];				\
	strm.get(_contents, (unsigned int)_count);			\
	for (CORBA::ULong i = _count; i< _num_allocated; i++)		\
		_contents[i] = (TYPE) 0;				\
}									\
									\
void SCOPE IDLSequence(TYPENAME)::copyFrom(NCistream& strm) 		\
{									\
	CORBA::ULong t_alloc, t_count;					\
	strm >> t_alloc >> t_count;					\
	if ( t_count > _count ) {					\
		if ( _num_allocated < t_count) {			\
			delete [] _contents;				\
			_contents = new TYPE[t_count];			\
			_num_allocated = t_count;			\
		}							\
	}								\
	_count = t_count;						\
	strm.get(_contents, (unsigned int)_count);			\
	for (CORBA::ULong i = _count; i< _num_allocated; i++)		\
		_contents[i] = (TYPE) 0;				\
}									\
									\
void SCOPE IDLSequence(TYPENAME)::write(NCostream& strm) const		\
{									\
	CORBA::Sequence::write(strm);					\
	strm << _num_allocated << _count;				\
	strm.put(_contents, (unsigned int)_count);			\
}									\
									\
void SCOPE IDLSequence(TYPENAME)::prettyPrint(NCostream& strm) const		\
{									\
	strm << "NUM OF ELEMENTS: " << _count << endl;			\
	for (CORBA::ULong i=0; i< _count; i++) {			\
		strm << "ELEMENT NUM: " << i << " = ";			\
		strm << _contents[i] << endl;				\
	}								\
}									\
									\
SCOPE IDLSequence(TYPENAME)::IDLSequence(TYPENAME)(CORBA::ULong initial_capacity) 		\
{									\
	_count = 0;							\
	if ( (_num_allocated = initial_capacity) == 0)			\
		_contents = NULL;					\
	else {								\
		_contents = new TYPE[_num_allocated];			\
		for (CORBA::ULong i=0; i< _num_allocated; i++)		\
			_contents[i] = (TYPE) 0;			\
	}								\
}									\
									\
SCOPE IDLSequence(TYPENAME)::IDLSequence(TYPENAME)(const SCOPE IDLSequence(TYPENAME)& seq) 			\
{									\
	_count = seq._count;						\
	_num_allocated = seq._num_allocated;				\
	if (_num_allocated == 0)					\
		_contents = NULL;					\
	else								\
		_contents = new TYPE[_num_allocated];		      	\
	for (CORBA::ULong i=0; i< _num_allocated; i++) {		\
		_contents[i] = seq._contents[i];			\
	}								\
}									\
									\
SCOPE IDLSequence(TYPENAME)& SCOPE IDLSequence(TYPENAME)::operator=(const SCOPE IDLSequence(TYPENAME)& seq) \
{									\
	_count = seq._count;						\
	_num_allocated = seq._num_allocated;				\
	if (_contents)							\
		delete [] _contents;					\
	if (_num_allocated == 0)					\
		_contents = NULL;					\
	else								\
		_contents = new TYPE[_num_allocated];		      	\
	for (CORBA::ULong i=0; i< _num_allocated; i++) {		\
		_contents[i] = seq._contents[i];			\
	}								\
	return *this;							\
}									\
									\
SCOPE IDLSequence(TYPENAME)::~IDLSequence(TYPENAME)()			\
{									\
	delete []  _contents;						\
}									\
									\
									\
									\
void SCOPE IDLSequence(TYPENAME)::insert(TYPE element, 			\
	CORBA::ULong index) {						\
	if (_count >= _num_allocated) {					\
		_num_allocated *= 2;					\
		TYPE *pmc_temp = new TYPE[_num_allocated];		\
		for (CORBA::ULong i = 0; i < _count; i++)		\
			pmc_temp[i] = _contents[i];			\
		for (; i < _num_allocated; i++)				\
			pmc_temp[i] = (TYPE) 0;				\
		delete []  _contents;					\
		_contents = pmc_temp;					\
	}								\
	for (CORBA::ULong i = _num_allocated-1; i>index; i--)		\
		_contents[i] = _contents[i-1];				\
	_contents[index] = element;					\
	_count++;							\
}									\
									\
CORBA::ULong SCOPE IDLSequence(TYPENAME)::append(TYPE element) {		\
	if (_count >= _num_allocated) {					\
		_num_allocated *= 2;					\
		TYPE *pmc_temp = new TYPE[_num_allocated];		\
		for (CORBA::ULong i = 0; i < _count; i++)		\
			pmc_temp[i] = _contents[i];			\
		for (; i < _num_allocated; i++)				\
			pmc_temp[i] = (TYPE) 0;				\
		delete []  _contents;					\
		_contents = pmc_temp;					\
	}								\
	_contents[_count++] = element;					\
	return _count;							\
}									\
									\
void SCOPE IDLSequence(TYPENAME)::remove(CORBA::ULong index) {		\
	if (index < _count) {						\
		for (CORBA::ULong i = index; i < _count-1; i++)		\
			_contents[i] = _contents[i+1];			\
		_contents[--_count] = (TYPE) 0;				\
	}								\
}									\
									\
TYPE& SCOPE IDLSequence(TYPENAME)::operator[](CORBA::ULong index) {		\
	return _contents[index];					\
}									\
const TYPE SCOPE IDLSequence(TYPENAME)::operator[](CORBA::ULong index) const {\
	return _contents[index];					\
}



#define DECLARE_CONSTRUCTED_SEQUENCE(TYPENAME,TYPE)			\
class IDLSequence(TYPENAME): public CORBA::Sequence				\
{									\
	DECLARE_NCOBJECT_CLASS(IDLSequence(TYPENAME));			\
    private:								\
	TYPE		**_contents;					\
	CORBA::ULong	_count;						\
	CORBA::ULong	_num_allocated;					\
									\
									\
    public:								\
	static const IDLSequence(TYPENAME)	_nil;			\
									\
	IDLSequence(TYPENAME)(CORBA::ULong initial_capacity=16);	\
	IDLSequence(TYPENAME)(const IDLSequence(TYPENAME)& );		\
	IDLSequence(TYPENAME)& operator=(const IDLSequence(TYPENAME)&);	\
	~IDLSequence(TYPENAME)();					\
	void copyFrom(NCistream &strm);					\
									\
	CORBA::ULong length() const { return _count; }			\
									\
	void	insert(const TYPE& element, CORBA::ULong index);	\
	void	insert(TYPE *element, CORBA::ULong index);		\
	CORBA::ULong append(const TYPE& element);			\
	CORBA::ULong append(TYPE *element);				\
	void	remove(CORBA::ULong index);				\
									\
	TYPE& operator[](CORBA::ULong index);				\
	const TYPE& operator[](CORBA::ULong index) const;		\
	CORBA::Boolean is_nil() const { return this == &_nil; }		\
}									

#define IMPLEMENT_CONSTRUCTED_SEQUENCE(TYPENAME,TYPE,SCOPE)			\
DEFINE_NCOBJECT_CLASS1(SCOPE IDLSequence(TYPENAME), CORBA::Sequence);		\
const SCOPE IDLSequence(TYPENAME) SCOPE IDLSequence(TYPENAME)::_nil(0);			\
									\
int SCOPE IDLSequence(TYPENAME)::compare(const NCObject& obj) const	\
{									\
	const SCOPE IDLSequence(TYPENAME)& temp = 			\
		NCCONST_REF_CAST(SCOPE IDLSequence(TYPENAME), obj);	\
	int diff = (int)(_count - temp._count);				\
	if ( diff != 0)							\
		return diff;						\
	for (CORBA::ULong i=0; i< _count; i++) {			\
		if ( (diff = (_contents[i]->compare(*temp._contents[i]))) != 0)\
			return diff;					\
	}								\
	return 0;							\
}									\
									\
unsigned SCOPE IDLSequence(TYPENAME)::hash() const			\
{									\
	unsigned h = (unsigned)_count;					\
	for (CORBA::ULong i=0; i< _count; i++)				\
		h ^= _contents[i]->hash();				\
	return h;							\
}									\
									\
SCOPE IDLSequence(TYPENAME)::IDLSequence(TYPENAME)(NCistream& strm) : CORBA::Sequence(strm)	\
{									\
	strm >> _num_allocated >> _count;				\
	_contents = new TYPE*[_num_allocated];				\
	for (CORBA::ULong i=0; i< _count; i++) {			\
		_contents[i] = new TYPE;				\
		_contents[i]->get(strm);				\
		DSResource::ref(_contents[i]);				\
	}								\
	for (; i< _num_allocated; i++) 					\
		_contents[i] = NULL;					\
}									\
									\
void SCOPE IDLSequence(TYPENAME)::copyFrom(NCistream& strm)		\
{									\
	CORBA::ULong t_alloc, t_count;					\
	strm >> t_alloc >> t_count;					\
	if ( t_count > _count) {					\
		if ( _num_allocated < t_count ) {			\
			TYPE **t_contents = new TYPE*[t_count];		\
			for (CORBA::ULong i=0; i< _count; i++)		\
				t_contents[i] = _contents[i];		\
			delete _contents;				\
			_contents = t_contents;				\
			_num_allocated = t_count;			\
		}							\
		for (CORBA::ULong i=_count; i< t_count; i++) {		\
			_contents[i] = new TYPE;			\
			DSResource::ref(_contents[i]);			\
		}							\
	}								\
	else if ( t_count < _count ) {					\
		for (CORBA::ULong i=t_count; i < _count; i++) {		\
			DSResource::unref(_contents[i]);		\
			_contents[i] = NULL;				\
		}							\
	}								\
	_count = t_count;						\
	for (CORBA::ULong i=0; i< _count; i++)				\
		_contents[i]->get(strm);				\
}									\
									\
void SCOPE IDLSequence(TYPENAME)::write(NCostream& strm) const		\
{									\
	CORBA::Sequence::write(strm);					\
	strm << _num_allocated << _count;				\
	for (CORBA::ULong i=0; i< _count; i++) 				\
		_contents[i]->put(strm);				\
}									\
									\
void SCOPE IDLSequence(TYPENAME)::prettyPrint(NCostream& strm) const	\
{									\
	strm << "NUM OF ELEMENTS: " << _count << endl;			\
	for (CORBA::ULong i=0; i< _count; i++) {			\
		strm << "ELEMENT NUM: " << i << endl;			\
		_contents[i]->prettyPrint(strm);			\
	}								\
}									\
									\
SCOPE IDLSequence(TYPENAME)::IDLSequence(TYPENAME)(CORBA::ULong initial_capacity)\
{									\
	_count = 0;							\
	if ( (_num_allocated = initial_capacity) == 0)			\
		_contents = NULL;					\
	else {								\
		_contents = new TYPE*[_num_allocated];			\
		for (CORBA::ULong i=0; i< _num_allocated; i++)		\
			_contents[i] = NULL;				\
	}								\
}									\
									\
SCOPE IDLSequence(TYPENAME)::IDLSequence(TYPENAME)(const SCOPE IDLSequence(TYPENAME)& seq)\
{									\
	_count = seq._count;						\
	_num_allocated = seq._num_allocated;				\
	if (_num_allocated == 0)					\
		_contents = NULL;					\
	else								\
		_contents = new TYPE*[_num_allocated];			\
	for (CORBA::ULong i=0; i< _num_allocated; i++) {		\
		_contents[i] = seq._contents[i];			\
		DSResource::ref(_contents[i]);				\
	}								\
}									\
									\
SCOPE IDLSequence(TYPENAME)& SCOPE IDLSequence(TYPENAME)::operator=(const SCOPE IDLSequence(TYPENAME)& seq)	\
{									\
	if (_contents) {						\
		for (CORBA::ULong i = 0; i < _count; i++)		\
			DSResource::unref(_contents[i]);		\
		delete [] _contents;					\
	}								\
	_count = seq._count;						\
	_num_allocated = seq._num_allocated;				\
	if (_num_allocated == 0)					\
		_contents = NULL;					\
	else								\
		_contents = new TYPE*[_num_allocated];			\
	for (CORBA::ULong i=0; i< _num_allocated; i++) {		\
		_contents[i] = seq._contents[i];			\
		DSResource::ref(_contents[i]);				\
	}								\
	return *this;							\
}									\
									\
SCOPE IDLSequence(TYPENAME)::~IDLSequence(TYPENAME)()			\
{									\
	for (CORBA::ULong i = 0; i < _count; i++)			\
		DSResource::unref(_contents[i]);			\
	delete []  _contents;						\
}									\
									\
									\
									\
void SCOPE IDLSequence(TYPENAME)::insert(const TYPE& element,		\
	CORBA::ULong index) {						\
	if (_count >= _num_allocated) {					\
		_num_allocated *= 2;					\
		TYPE **pmc_temp = new TYPE*[_num_allocated];		\
		for (CORBA::ULong i = 0; i < _count; i++)		\
			pmc_temp[i] = _contents[i];			\
		for (; i < _num_allocated; i++)				\
			pmc_temp[i] = NULL;				\
		delete []  _contents;					\
		_contents = pmc_temp;					\
	}								\
	for (CORBA::ULong i = _num_allocated-1; i>index; i--)		\
		_contents[i] = _contents[i-1];				\
	_contents[index] = new TYPE(element);				\
	DSResource::ref(_contents[index]);				\
	_count++;							\
}									\
									\
void SCOPE IDLSequence(TYPENAME)::insert(TYPE  *element,		\
	CORBA::ULong index) {						\
	if (_count >= _num_allocated) {					\
		_num_allocated *= 2;					\
		TYPE **pmc_temp = new TYPE*[_num_allocated];		\
		for (CORBA::ULong i = 0; i < _count; i++)		\
			pmc_temp[i] = _contents[i];			\
		for (; i < _num_allocated; i++)				\
			pmc_temp[i] = NULL;				\
		delete []  _contents;					\
		_contents = pmc_temp;					\
	}								\
	for (CORBA::ULong i = _num_allocated-1; i>index; i--)		\
		_contents[i] = _contents[i-1];				\
	_contents[index] = element;					\
	DSResource::ref(_contents[index]);				\
	_count++;							\
}									\
									\
CORBA::ULong SCOPE IDLSequence(TYPENAME)::append(const TYPE& element) {	\
	if (_count >= _num_allocated) {					\
		_num_allocated *= 2;					\
		TYPE **pmc_temp = new TYPE*[_num_allocated];		\
		for (CORBA::ULong i = 0; i < _count; i++)		\
			pmc_temp[i] = _contents[i];			\
		for (; i < _num_allocated; i++)				\
			pmc_temp[i] = NULL;				\
		delete []  _contents;					\
		_contents = pmc_temp;					\
	}								\
	_contents[_count++] = new TYPE(element);			\
	DSResource::ref(_contents[_count-1]);				\
	return _count;							\
}									\
									\
CORBA::ULong SCOPE IDLSequence(TYPENAME)::append(TYPE *element) {	\
	if (_count >= _num_allocated) {					\
		_num_allocated *= 2;					\
		TYPE **pmc_temp = new TYPE*[_num_allocated];		\
		for (CORBA::ULong i = 0; i < _count; i++)		\
			pmc_temp[i] = _contents[i];			\
		for (; i < _num_allocated; i++)				\
			pmc_temp[i] = NULL;				\
		delete []  _contents;					\
		_contents = pmc_temp;					\
	}								\
	_contents[_count++] = element;					\
	DSResource::ref(_contents[_count-1]);				\
	return _count;							\
}									\
									\
void SCOPE IDLSequence(TYPENAME)::remove(CORBA::ULong index) {		\
	if (index < _count) {						\
		DSResource::unref(_contents[index]);			\
		for (CORBA::ULong i = index; i < _count-1; i++)		\
			_contents[i] = _contents[i+1];			\
		_contents[--_count] = NULL;				\
	}								\
}									\
									\
const TYPE& SCOPE IDLSequence(TYPENAME)::operator[](CORBA::ULong index) const {\
	return *_contents[index];					\
}									\
									\
TYPE& SCOPE IDLSequence(TYPENAME)::operator[](CORBA::ULong index) {	\
	return *_contents[index];					\
}


#define DECLARE_ENUM_SEQUENCE(TYPENAME,TYPE)	 			\
class IDLSequence(TYPENAME): public CORBA::Sequence			\
{									\
	DECLARE_NCOBJECT_CLASS(IDLSequence(TYPENAME));			\
    private:								\
	TYPE		*_contents;					\
	CORBA::ULong	_count;						\
	CORBA::ULong	_num_allocated;					\
									\
									\
    public:								\
	static const IDLSequence(TYPENAME)	_nil;			\
									\
	IDLSequence(TYPENAME)(CORBA::ULong initial_capacity=16);	\
	IDLSequence(TYPENAME)(const IDLSequence(TYPENAME)& );		\
	IDLSequence(TYPENAME)& operator=(const IDLSequence(TYPENAME)&);	\
	~IDLSequence(TYPENAME)();					\
	void copyFrom(NCistream &strm);					\
	CORBA::ULong length() const { return _count; }			\
									\
	void	insert(TYPE element, CORBA::ULong index);		\
	CORBA::ULong append(TYPE element);				\
	void	remove(CORBA::ULong index);				\
									\
	const TYPE operator[](CORBA::ULong index) const;		\
	TYPE& operator[](CORBA::ULong index);				\
	CORBA::Boolean _is_nil() const { return this == &_nil; }	\
}									

#define IMPLEMENT_ENUM_SEQUENCE(TYPENAME,TYPE,SCOPE)				\
DEFINE_NCOBJECT_CLASS1(SCOPE IDLSequence(TYPENAME), CORBA::Sequence);		\
const SCOPE IDLSequence(TYPENAME) SCOPE IDLSequence(TYPENAME)::_nil(0);			\
									\
int SCOPE IDLSequence(TYPENAME)::compare(const NCObject& obj) const		\
{									\
	const SCOPE IDLSequence(TYPENAME)& temp = 				\
		NCCONST_REF_CAST(SCOPE IDLSequence(TYPENAME), obj);		\
	int diff = (int)(_count - temp._count);				\
	if ( diff != 0)							\
		return diff;						\
	for (CORBA::ULong i=0; i< _count; i++) {			\
		if ( (diff = ((int)_contents[i] - (int)temp._contents[i])) != 0)\
			return diff;					\
	}								\
	return 0;							\
}									\
									\
unsigned SCOPE IDLSequence(TYPENAME)::hash() const				\
{									\
	unsigned h = (unsigned)_count;					\
	for (CORBA::ULong i=0; i< _count; i++)				\
		h ^= (unsigned) _contents[i];				\
	return h;							\
}									\
									\
SCOPE IDLSequence(TYPENAME)::IDLSequence(TYPENAME)(NCistream& strm) : CORBA::Sequence(strm)	\
{									\
	strm >> _num_allocated >> _count;				\
	_contents = new TYPE[_num_allocated];				\
	CORBA::ULong temp;						\
	for (CORBA::ULong i = 0; i < _count; i++) {			\
		strm >> temp;						\
		_contents[i] = TYPE(temp);				\
	}								\
	for (i = _count; i< _num_allocated; i++)			\
		_contents[i] = TYPE(0);					\
}									\
									\
void SCOPE IDLSequence(TYPENAME)::copyFrom(NCistream& strm) 		\
{									\
	CORBA::ULong t_alloc, t_count;					\
	strm >> t_alloc >> t_count;					\
	if ( t_count > _count ) {					\
		if ( _num_allocated < t_count) {			\
			delete [] _contents;				\
			_contents = new TYPE[t_count];			\
			_num_allocated = t_count;			\
		}							\
	}								\
	_count = t_count;						\
	CORBA::ULong temp;						\
	for (CORBA::ULong i = 0; i < _count; i++) {			\
		strm >> temp;						\
		_contents[i] = TYPE(temp);				\
	}								\
}									\
									\
void SCOPE IDLSequence(TYPENAME)::write(NCostream& strm) const		\
{									\
	CORBA::Sequence::write(strm);					\
	strm << _num_allocated << _count;				\
	for (CORBA::ULong i = 0; i < _count; i++) 			\
		strm << (CORBA::ULong) _contents[i];			\
}									\
									\
void SCOPE IDLSequence(TYPENAME)::prettyPrint(NCostream& strm) const		\
{									\
	strm << "NUM OF ELEMENTS: " << _count << endl;			\
	for (CORBA::ULong i=0; i< _count; i++) {			\
		strm << "ELEMENT NUM: " << i << " = ";			\
		strm << _contents[i] << endl;				\
	}								\
}									\
									\
SCOPE IDLSequence(TYPENAME)::IDLSequence(TYPENAME)(CORBA::ULong initial_capacity) \
{									\
	_count = 0;							\
	if ( (_num_allocated = initial_capacity) == 0)			\
		_contents = NULL;					\
	else {								\
		_contents = new TYPE[_num_allocated];			\
		for (CORBA::ULong i=0; i< _num_allocated; i++)		\
			_contents[i] = TYPE(0);				\
	}								\
}									\
									\
SCOPE IDLSequence(TYPENAME)::IDLSequence(TYPENAME)(const SCOPE IDLSequence(TYPENAME)& seq)\
{									\
	_count = seq._count;						\
	_num_allocated = seq._num_allocated;				\
	if (_num_allocated == 0)					\
		_contents = NULL;					\
	else								\
		_contents = new TYPE[_num_allocated];		      	\
	for (CORBA::ULong i=0; i< _num_allocated; i++) {		\
		_contents[i] = seq._contents[i];			\
	}								\
}									\
									\
SCOPE IDLSequence(TYPENAME)& SCOPE IDLSequence(TYPENAME)::operator=(const SCOPE IDLSequence(TYPENAME)& seq)	\
{									\
	_count = seq._count;						\
	_num_allocated = seq._num_allocated;				\
	if (_contents)							\
		delete [] _contents;					\
	if (_num_allocated == 0)					\
		_contents = NULL;					\
	else								\
		_contents = new TYPE[_num_allocated];		      	\
	for (CORBA::ULong i=0; i< _num_allocated; i++) {		\
		_contents[i] = seq._contents[i];			\
	}								\
	return *this;							\
}									\
									\
SCOPE IDLSequence(TYPENAME)::~IDLSequence(TYPENAME)()			\
{									\
	delete []  _contents;						\
}									\
									\
									\
									\
void SCOPE IDLSequence(TYPENAME)::insert(TYPE element, 			\
	CORBA::ULong index) {						\
	if (_count >= _num_allocated) {					\
		_num_allocated *= 2;					\
		TYPE *pmc_temp = new TYPE[_num_allocated];		\
		for (CORBA::ULong i = 0; i < _count; i++)		\
			pmc_temp[i] = _contents[i];			\
		for (; i < _num_allocated; i++)				\
			pmc_temp[i] = TYPE(0);				\
		delete []  _contents;					\
		_contents = pmc_temp;					\
	}								\
	for (CORBA::ULong i = _num_allocated-1; i>index; i--)		\
		_contents[i] = _contents[i-1];				\
	_contents[index] = element;					\
	_count++;							\
}									\
									\
CORBA::ULong SCOPE IDLSequence(TYPENAME)::append(TYPE element) {		\
	if (_count >= _num_allocated) {					\
		_num_allocated *= 2;					\
		TYPE *pmc_temp = new TYPE[_num_allocated];		\
		for (CORBA::ULong i = 0; i < _count; i++)		\
			pmc_temp[i] = _contents[i];			\
		for (; i < _num_allocated; i++)				\
			pmc_temp[i] = TYPE(0);				\
		delete []  _contents;					\
		_contents = pmc_temp;					\
	}								\
	_contents[_count++] = element;					\
	return _count;							\
}									\
									\
void SCOPE IDLSequence(TYPENAME)::remove(CORBA::ULong index) {		\
	if (index < _count) {						\
		for (CORBA::ULong i = index; i < _count-1; i++)		\
			_contents[i] = _contents[i+1];			\
		_contents[--_count] = TYPE(0);				\
	}								\
}									\
									\
TYPE& SCOPE IDLSequence(TYPENAME)::operator[](CORBA::ULong index) {		\
	return _contents[index];					\
}									\
const TYPE SCOPE IDLSequence(TYPENAME)::operator[](CORBA::ULong index) const {\
	return _contents[index];					\
}


#define DECLARE_INTERFACE_SEQUENCE(TYPENAME,TYPE)			\
class IDLSequence(TYPENAME): public CORBA::Sequence			\
{									\
	DECLARE_NCOBJECT_CLASS(IDLSequence(TYPENAME));			\
    private:								\
	TYPE		**_contents;					\
	CORBA::ULong	_count;						\
	CORBA::ULong	_num_allocated;					\
									\
									\
    public:								\
	static const IDLSequence(TYPENAME)	_nil;			\
									\
	IDLSequence(TYPENAME)(CORBA::ULong initial_capacity=16);	\
	IDLSequence(TYPENAME)(const IDLSequence(TYPENAME)& );		\
	IDLSequence(TYPENAME)& operator=(const IDLSequence(TYPENAME)&);	\
	~IDLSequence(TYPENAME)();					\
	void copyFrom(NCistream &strm);					\
									\
	CORBA::ULong length() const { return _count; }			\
									\
	void	insert(TYPE *element, CORBA::ULong index);		\
	CORBA::ULong append(TYPE *element);				\
	void	remove(CORBA::ULong index);				\
									\
	TYPE*& operator[](CORBA::ULong index);				\
	TYPE*  operator[](CORBA::ULong index) const;			\
	CORBA::Boolean is_nil() const { return this == &_nil; }		\
}									

#define IMPLEMENT_INTERFACE_SEQUENCE(TYPENAME,TYPE,SCOPE)			\
DEFINE_NCOBJECT_CLASS1(SCOPE IDLSequence(TYPENAME), CORBA::Sequence);		\
const SCOPE IDLSequence(TYPENAME) SCOPE IDLSequence(TYPENAME)::_nil(0);			\
									\
int SCOPE IDLSequence(TYPENAME)::compare(const NCObject& obj) const		\
{									\
	const SCOPE IDLSequence(TYPENAME)& temp = 				\
		NCCONST_REF_CAST(SCOPE IDLSequence(TYPENAME), obj);		\
	int diff = (int)(_count - temp._count);				\
	if ( diff != 0)							\
		return diff;						\
	for (CORBA::ULong i=0; i< _count; i++) {			\
		if ( (diff = (int)((unsigned long)_contents[i] - 	\
				(unsigned long)temp._contents[i])) != 0)\
			return diff;					\
	}								\
	return 0;							\
}									\
									\
unsigned SCOPE IDLSequence(TYPENAME)::hash() const				\
{									\
	unsigned h = (unsigned)_count;					\
	for (CORBA::ULong i=0; i< _count; i++)				\
		h ^= (unsigned) (unsigned long)_contents[i];		\
	return h;							\
}									\
									\
SCOPE IDLSequence(TYPENAME)::IDLSequence(TYPENAME)(NCistream& strm) : CORBA::Sequence(strm)	\
{									\
	strm >> _num_allocated >> _count;				\
	_contents = new TYPE*[_num_allocated];				\
	for (CORBA::ULong i=0; i< _count; i++) {			\
		_contents[i] = TYPE::_narrow(CORBA::Object::_read(strm, TYPE::_desc())); \
	}								\
	for (; i< _num_allocated; i++) 					\
		_contents[i] = NULL;					\
}									\
									\
void SCOPE IDLSequence(TYPENAME)::copyFrom(NCistream& strm)			\
{									\
	for (CORBA::ULong i=0; i< _count; i++)				\
		_contents[i]->_release();				\
	delete [] _contents;						\
	strm >> _num_allocated >> _count;				\
	_contents = new TYPE*[_num_allocated];				\
	for (i=0; i< _count; i++) {			\
		_contents[i] = TYPE::_narrow(CORBA::Object::_read(strm, TYPE::_desc())); \
	}								\
	for (; i< _num_allocated; i++) 					\
		_contents[i] = NULL;					\
}									\
									\
void SCOPE IDLSequence(TYPENAME)::write(NCostream& strm) const		\
{									\
	CORBA::Sequence::write(strm);					\
	strm << _num_allocated << _count;				\
	for (CORBA::ULong i=0; i< _count; i++) 				\
		CORBA::Object::_write(_contents[i], strm, 		\
			TYPE::_desc());				\
}									\
									\
void SCOPE IDLSequence(TYPENAME)::prettyPrint(NCostream& strm) const		\
{									\
	strm << "NUM OF ELEMENTS: " << _count << endl;			\
	for (CORBA::ULong i=0; i< _count; i++) {			\
		strm << "ELEMENT NUM: " << i << endl;			\
		strm << _contents[i]->_interface_name();		\
	}								\
}									\
									\
SCOPE IDLSequence(TYPENAME)::IDLSequence(TYPENAME)(CORBA::ULong initial_capacity)\
{									\
	_count = 0;							\
	if ( (_num_allocated = initial_capacity) == 0)			\
		_contents = NULL;					\
	else {								\
		_contents = new TYPE*[_num_allocated];			\
		for (CORBA::ULong i=0; i< _num_allocated; i++)		\
			_contents[i] = NULL;				\
	}								\
}									\
									\
SCOPE IDLSequence(TYPENAME)::IDLSequence(TYPENAME)(const SCOPE IDLSequence(TYPENAME)& seq)\
{									\
	_count = seq._count;						\
	_num_allocated = seq._num_allocated;				\
	if (_num_allocated == 0)					\
		_contents = NULL;					\
	else								\
		_contents = new TYPE*[_num_allocated];			\
	for (CORBA::ULong i=0; i< _num_allocated; i++) {		\
		_contents[i] = seq._contents[i];			\
		if (_contents[i] != NULL)				\
			_contents[i]->_ref();				\
	}								\
}									\
									\
SCOPE IDLSequence(TYPENAME)& SCOPE IDLSequence(TYPENAME)::operator=(const SCOPE IDLSequence(TYPENAME)& seq)	\
{									\
	if (_contents) {						\
		for (CORBA::ULong i = 0; i < _count; i++)		\
			_contents[i]->_release();			\
		delete [] _contents;					\
	}								\
	_count = seq._count;						\
	_num_allocated = seq._num_allocated;				\
	if (_num_allocated == 0)					\
		_contents = NULL;					\
	else								\
		_contents = new TYPE*[_num_allocated];			\
	for (CORBA::ULong i=0; i< _num_allocated; i++) {		\
		_contents[i] = seq._contents[i];			\
		if (_contents[i] != NULL)				\
			_contents[i]->_ref();				\
	}								\
	return *this;							\
}									\
									\
SCOPE IDLSequence(TYPENAME)::~IDLSequence(TYPENAME)()			\
{									\
	for (CORBA::ULong i = 0; i < _count; i++)			\
		_contents[i]->_release();				\
	delete []  _contents;						\
}									\
									\
									\
void SCOPE IDLSequence(TYPENAME)::insert(TYPE  *element,			\
	CORBA::ULong index) {						\
	if (_count >= _num_allocated) {					\
		_num_allocated *= 2;					\
		TYPE **pmc_temp = new TYPE*[_num_allocated];		\
		for (CORBA::ULong i = 0; i < _count; i++)		\
			pmc_temp[i] = _contents[i];			\
		for (; i < _num_allocated; i++)				\
			pmc_temp[i] = NULL;				\
		delete []  _contents;					\
		_contents = pmc_temp;					\
	}								\
	for (CORBA::ULong i = _num_allocated-1; i>index; i--)		\
		_contents[i] = _contents[i-1];				\
	_contents[index] = element;					\
	_count++;							\
}									\
									\
CORBA::ULong SCOPE IDLSequence(TYPENAME)::append(TYPE *element) {		\
	if (_count >= _num_allocated) {					\
		_num_allocated *= 2;					\
		TYPE **pmc_temp = new TYPE*[_num_allocated];		\
		for (CORBA::ULong i = 0; i < _count; i++)		\
			pmc_temp[i] = _contents[i];			\
		for (; i < _num_allocated; i++)				\
			pmc_temp[i] = NULL;				\
		delete []  _contents;					\
		_contents = pmc_temp;					\
	}								\
	_contents[_count++] = element;					\
	_contents[_count-1]->_ref();					\
	return _count;							\
}									\
									\
void SCOPE IDLSequence(TYPENAME)::remove(CORBA::ULong index) {		\
	if (index < _count) {						\
		_contents[index]->_release();				\
		for (CORBA::ULong i = index; i < _count-1; i++)		\
			_contents[i] = _contents[i+1];			\
		_contents[--_count] = NULL;				\
	}								\
}									\
									\
TYPE*& SCOPE IDLSequence(TYPENAME)::operator[](CORBA::ULong index) {	\
	return _contents[index];					\
}									\
									\
TYPE* SCOPE IDLSequence(TYPENAME)::operator[](CORBA::ULong index) const {\
	return _contents[index];					\
}





#endif
