#ifndef _typeinfo_h_
#define _typeinfo_h_
/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1993, 1994 by PostModern Computing Technologies, Inc.         */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/*  Author: psm                                                             */
/*                                                                          */
/****************************************************************************/

typedef Object *(*ObjectReader)(NCistream& strm);
class TypeInfo
{
    private:
	const char	*_name;
	ObjectReader	_reader;
	short		_num_bases;
	TypeInfo	**_bases;

	TypeInfo(const TypeInfo& );
	TypeInfo& operator=(const TypeInfo& );
    public:
	TypeInfo(const char *name, ObjectReader readfunc, ...);
	virtual ~TypeInfo();

	int operator==(const TypeInfo& p) const {
		return (_name == p._name);
	}
	const char *className() const { return _name; }
	ObjectReader reader() const { return _reader; }
	
	int hasBase(const TypeInfo& p) const;
	int canCast(const TypeInfo& p) const {
		return ( this == &p || hasBase(p) );
	}
	int numBases() const { return _num_bases; }
        TypeInfo *const * bases() const { return _bases; }
	static const TypeInfo *typeInfo(const char *name);
	static ObjectReader reader(const char *name);
};
#endif
	
